/**
* A class that represents a rational number. 
*/

public class Rational {
  
  // instance variables
  private int numerator;
  private int denominator;
  
  /**
  * The default constructor for objects of class Rational.  
  * Creates the rational number 1.
  */
  public Rational() {             }
  
  public Rational(int n) {                  } 
  
  /**
  * The alternate constructor for objects of class Rational.  
  * Creates a rational number equivalent to n/d.
  */    
  public Rational(int n, int d) {


    

    if(denominator == 0)
      throw new ZeroDenominatorException(
        "Can not have a zero denominator");
    
    normalize();
  }
  
  /**
  * Get the value of the Numerator
  * @return     the value of the numerator
  */
  public int getNumerator() {


    //dummy 
    return 0;
  }
  
  /**
  * Get the value of the Denominator
  * @return     the value of the denominator
  */
  public int getDenominator() {

    return 0;
  }
  
  /**
  * Negate a rational number r
  * @return a new rational number that is negation of this number -r
  */    
  public Rational negate() {               
  

    
    return null;
  }
  
  /**
  * Invert a rational number r 
  * @return a new rational number that is 1/r.
  */    
  public Rational invert() {               
    
    

    return null;
  }
  
  /**
  * Add two rational numbers
  * @param other the second argument of the add
  * @return a new rational number that is the sum of this and the 
  * other rational
  */    
  public Rational add(Rational other) {       

  

    
    return null;
  }
  
  
  /**
  * Multiply two rational numbers
  * @param other the second argument of multiply
  * @return a new rational number that is the sum of this 
  * object and the other rational.
  */    
  public Rational multiply(Rational other) {       
   


     return null;
  }
  
  
  
  public boolean equals(Object other) {
    
 




    return false;
    
  }
  
  
  /**
  * Put the rational number in normal form where the numerator
  * and the denominator share no common factors.  
  * Guarantee that only the numerator is negative.
  */


  private void normalize() {
    int absNumerator = Math.abs(numerator);
    int absDenominator = Math.abs(denominator);
    int signDenominator = denominator/absDenominator;
    
    int divideBy = gcd(absNumerator, absDenominator);
    numerator = (numerator / divideBy) * signDenominator;
    denominator = (denominator / divideBy) * signDenominator;
  }


  
  /**
  * Recursively compute the greatest common divisor of 
  * two positive integers
  * @param a the first argument of gcd
  * @param b the second argument of gcd
  * @return the gcd of the two arguments
  */
  public static int gcd(int a, int b) {
    






    return 0;
  }
  

  public static Rational add(Rational other1, Rational other2) {       






  }
    
  
  public String toString() {






    return null;
  }

}

class ZeroDenominatorException extends RuntimeException { 
  
  public ZeroDenominatorException(String mes) { 
    super(mes); 
  }
}
